Index: Handler.h
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/Handler.h,v
retrieving revision 1.40
retrieving revision 1.47
diff -u -p -b -r1.40 -r1.47
--- Handler.h	18 Jun 2004 19:42:43 -0000	1.40
+++ Handler.h	8 Jan 2005 16:22:02 -0000	1.47
@@ -1,5 +1,6 @@
 /////////////////////////////////////////////////////////////////////
-//  File: Handler.h
+// $Id: Handler.h,v 1.47 2005/01/08 16:22:02 klas Exp $
+//
 // Usage: the main loop for connected clients and interpreter for
 //        ftp commands.
 //
@@ -17,14 +18,15 @@
 #include "Configuration.h"
 #include "Utilities.h"
 #include "StringTokenizer.h"
+#include "Log.h"
 #endif
 
 struct command_info {
-  const string command;
+  const string command; //the command name
   const int ant_arg; //Number of arguments. -1 means variable size.
-  bool (Commands::*pf)(User*, string);
-  const int extra_flag;
-  const char *hlp_info;
+  bool (Commands::*pf)(User*, string, unsigned int); //the function we will call
+  const unsigned int extra_flag; //extra flags that is needed by that function
+  const string hlp_info; //the help field, if this is empty no help will be displayed
 };
 
 class Handler
@@ -37,20 +39,11 @@ class Handler
     static struct command_info cmd_info[];
 };
 
-class dns_wrapper
-{
-  public:
-    struct sockaddr_in addr;
-    string *host_name;
-};
-
 extern class Commands comm;
 extern class Configuration *config;
 extern bool term;
 extern bool hup;
 extern vector<User*> user_list;
-extern pthread_mutex_t user_list_mutex;
-extern pthread_mutex_t sys_log_lock;
-void *dns_lookup(void*);
+extern sem_t user_list_lock;
 
 #endif
Index: Log.cpp
===================================================================
RCS file: Log.cpp
diff -N Log.cpp
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ Log.cpp	23 Jan 2005 17:56:47 -0000	1.21
@@ -0,0 +1,187 @@
+///////////////////////////////////////////////////////////////////
+//  $Id: Log.cpp,v 1.21 2005/01/23 17:56:47 klas Exp $
+//
+//  Usage: Logging functions etc.
+//
+//  A part of babyftpd, licensed under the GNU GPL, see the file
+//    LICENSE for complete information.
+/////////////////////////////////////////////////////////////////////
+
+#define __LOG_CPP__
+#include "Log.h"
+
+Log::Log(void)
+{
+  sem_init(&this->to_log_lock, 0, 1); // 1 means it is not locked
+  sem_init(&this->data_ready, 0, 0); // and 0 means it is locked, flagged to 1 when there is data
+
+  openlog("BabyFTPd", LOG_PID, LOG_FTP);
+}
+
+Log::~Log(void)
+{
+  closelog();
+
+  sem_destroy(&this->to_log_lock);
+  sem_destroy(&this->data_ready);
+}
+
+void Log::log_this(int log_level, int log_type, string log_message)
+{
+  if(log_level > config->logger.log_level && log_type != TYPE_XFER)
+    return; // no point in pushing data that wont be logged..
+
+  struct log_data temp_data = {log_level, log_type, log_message};
+
+  if(temp_data.type != TYPE_XFER && config->logger.thread_id)
+    temp_data.message += " (" + util.itos(pthread_self()) + ")";
+
+  sem_wait(&this->to_log_lock);
+  this->to_log.push_back(temp_data);
+  sem_post(&this->to_log_lock);
+
+  sem_post(&this->data_ready); // bump data_ready to tell main thread there is data
+}
+
+
+void Log::log_main(void)
+{
+  setuid(config->general.user);
+  while(true)
+  {
+    sem_wait(&this->data_ready); // if data_ready is zero we wait for it to increase
+
+    if(this->to_log.size() == 0)
+    {
+      this->log_this(3, TYPE_DEBUG, "data->ready triggered without there being any data to log.");
+      continue;
+    }
+
+    sem_wait(&this->to_log_lock);
+    struct log_data temp_data = this->to_log.front();
+    this->to_log.erase(this->to_log.begin());
+    sem_post(&this->to_log_lock);
+
+    switch(temp_data.level)
+    {
+      case 0:
+        temp_data.level = LOG_CRIT;
+        break;
+
+      case 1:
+        temp_data.level = LOG_ERR;
+        break;
+
+      case 2:
+        temp_data.level = LOG_WARNING;
+        break;
+
+      case 3:
+        temp_data.level = LOG_NOTICE;
+        break;
+
+      case 4:
+        temp_data.level = LOG_INFO;
+        break;
+
+      case 5:
+      default: // so we get everything else as well ;)
+        temp_data.level = LOG_DEBUG;
+        break;
+    }
+
+    switch(temp_data.type)
+    {
+      case TYPE_XFER:
+        this->xferlog(temp_data);
+        break;
+
+      case TYPE_AUTH:
+        this->authlog(temp_data);
+        break;
+
+      case TYPE_INFO:
+        this->infolog(temp_data);
+        break;
+
+      case TYPE_DEBUG:
+        this->debuglog(temp_data);
+        break;
+    }
+  }
+}
+
+void Log::xferlog(struct log_data data_to_log)
+{
+  ofstream xstream;
+  xstream.open(config->logger.xferlog_file.c_str(),
+      ofstream::out | ofstream::app);
+  if(!xstream)
+    log_this(2, TYPE_INFO, "Failed to open xferlog file \""
+        + config->logger.xferlog_file  + "\" for writing, check permissions.");
+  else
+  {
+    xstream << data_to_log.message << endl;
+    xstream.close();
+  }
+}
+
+void Log::authlog(struct log_data data_to_log)
+{
+  if(config->logger.authlog.empty())
+    syslog(LOG_AUTHPRIV | data_to_log.level, data_to_log.message.c_str());
+  else
+  {
+    ofstream astream;
+    astream.open(config->logger.authlog.c_str(),
+        ofstream::out | ofstream::app);
+    if(!astream)
+      log_this(2, TYPE_INFO, "Failed to open authlog file \""
+          + config->logger.authlog  + "\" for writing, check permissions.");
+    else
+    {
+      astream << data_to_log.message << endl;
+      astream.close();
+    }
+  }
+}
+
+  void Log::infolog(struct log_data data_to_log)
+  {
+  if(config->logger.infolog.empty())
+    syslog(LOG_FTP | data_to_log.level, data_to_log.message.c_str());
+  else
+  {
+    ofstream istream;
+    istream.open(config->logger.infolog.c_str(),
+        ofstream::out | ofstream::app);
+    if(!istream)
+      log_this(2, TYPE_INFO, "Failed to open infolog file \""
+          + config->logger.infolog  + "\" for writing, check permissions.");
+    else
+    {
+      istream << data_to_log.message << endl;
+      istream.close();
+    }
+  }
+}
+
+void Log::debuglog(struct log_data data_to_log)
+{
+  if(config->logger.infolog.empty())
+    syslog(LOG_FTP | data_to_log.level, data_to_log.message.c_str());
+  else
+  {
+    ofstream dstream;
+    dstream.open(config->logger.debuglog.c_str(),
+        ofstream::out | ofstream::app);
+    if(!dstream)
+      log_this(2, TYPE_INFO, "Failed to open debuglog file \""
+          + config->logger.debuglog  + "\" for writing, check permissions.");
+    else
+    {
+      dstream << data_to_log.message << endl;
+      dstream.close();
+    }
+  }
+}
Index: Log.h
===================================================================
RCS file: Log.h
diff -N Log.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ Log.h	17 Jan 2005 22:21:44 -0000	1.8
@@ -0,0 +1,53 @@
+/////////////////////////////////////////////////////////////////////
+//  $Id: Log.h,v 1.8 2005/01/17 22:21:44 klas Exp $
+//
+//  Usage: Logging defines, functions etc.
+//
+//  A part of babyftpd, licensed under the GNU GPL, see the file
+//    LICENSE for complete information.
+/////////////////////////////////////////////////////////////////////
+
+#ifndef __LOG_H__
+#define __LOG_H__
+
+#ifdef __LOG_CPP__
+#include "generic.h"
+#include "Configuration.h"
+#include "Utilities.h"
+#endif // __LOG_CPP__
+
+class Log
+{
+  private:
+    vector<struct log_data> to_log;
+    sem_t to_log_lock; // locking the vector when we push/pop it
+    sem_t data_ready; // flagging this when there is data available for logging
+    void xferlog(struct log_data);
+    void authlog(struct log_data);
+    void infolog(struct log_data);
+    void debuglog(struct log_data);
+
+  public:
+    void log_main(void);
+    void log_this(int, int, string);
+    Log(void);
+    ~Log(void);
+};
+
+
+struct log_data
+{
+  int level;
+  int type;
+  string message;
+};
+
+extern class Log *logging;
+extern class Configuration *config;
+
+#define TYPE_XFER 1
+#define TYPE_AUTH 2
+#define TYPE_INFO 3
+#define TYPE_DEBUG 4
+
+#endif // __LOG_H__
Index: README
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/README,v
retrieving revision 1.12
retrieving revision 1.13
diff -u -p -b -r1.12 -r1.13
--- README	10 Jul 2004 14:20:19 -0000	1.12
+++ README	7 Oct 2004 20:55:20 -0000	1.13
@@ -14,7 +14,7 @@ http://cr.yp.to/ftp.html
 http://rfc2428.x42.com/
 http://www.ietf.org/proceedings/02jul/I-D/draft-ietf-ftpext-data-connection-assurance-00.txt
 http://rfc2228.x42.com/
-http://www.ford-hutchinson.com/~fh-1-pfh/draft-murray-auth-ftp-ssl-14.txt
+http://www.ford-hutchinson.com/~fh-1-pfh/draft-murray-auth-ftp-ssl-15.txt
 
 more standards and the like will follow here..
 
Index: StringTokenizer.cpp
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/StringTokenizer.cpp,v
retrieving revision 1.8
retrieving revision 1.9
diff -u -p -b -r1.8 -r1.9
--- StringTokenizer.cpp	20 May 2004 21:33:43 -0000	1.8
+++ StringTokenizer.cpp	16 Jan 2005 01:19:12 -0000	1.9
@@ -1,5 +1,6 @@
 /////////////////////////////////////////////////////////////////////
-//  File: StringTokenizer.cpp
+// $Id: StringTokenizer.cpp,v 1.9 2005/01/16 01:19:12 klas Exp $
+//
 // Usage: Used to chop up a string in "tokens"
 //
 //  A part of babyftpd, licensed under the GNU GPL, see the file
@@ -64,7 +65,7 @@ bool StringTokenizer::isDelimiter(char c
 int StringTokenizer::skipDelimiters(int startPos) 
 {
   if (delimiters.compare("") == 0)  
-    cout << "Error: NullPointerException." << endl;
+    logging->log_this(2, TYPE_INFO, "Error: NullPointerException.");
     
   int position = startPos;
   while (!retDelims && position < maxPosition) {
@@ -92,7 +93,7 @@ string StringTokenizer::nextToken()
   newPosition = -1;
 
   if (currentPosition >= maxPosition)
-    cout << "NoSuchElementException." << endl;
+    logging->log_this(2, TYPE_INFO, "NoSuchElementException.");
   
   int start = currentPosition;
   currentPosition = scanToken(currentPosition);
Index: StringTokenizer.h
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/StringTokenizer.h,v
retrieving revision 1.6
retrieving revision 1.8
diff -u -p -b -r1.6 -r1.8
--- StringTokenizer.h	20 May 2004 21:33:43 -0000	1.6
+++ StringTokenizer.h	16 Jan 2005 01:19:12 -0000	1.8
@@ -1,16 +1,18 @@
 /////////////////////////////////////////////////////////////////////
-//  File: StringTokenizer.h
+// $Id: StringTokenizer.h,v 1.8 2005/01/16 01:19:12 klas Exp $
+//
 // Usage: Used to chop up a string in "tokens"
 //
 //  A part of babyftpd, licensed under the GNU GPL, see the file
 //    LICENSE for complete information.
 /////////////////////////////////////////////////////////////////////
 
-#ifndef __STRINGTOKENIZER_H_
-#define __STRINGTOKENIZER_H_
+#ifndef __STRINGTOKENIZER_H__
+#define __STRINGTOKENIZER_H__
 
 #ifdef __STRINGTOKENIZER_CPP__
 #include "generic.h"
+#include "Log.h"
 #endif
 
 class StringTokenizer
Index: User.cpp
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/User.cpp,v
retrieving revision 1.51
retrieving revision 1.70
diff -u -p -b -r1.51 -r1.70
--- User.cpp	10 Jul 2004 14:14:45 -0000	1.51
+++ User.cpp	23 Jan 2005 01:34:53 -0000	1.70
@@ -1,5 +1,6 @@
 /////////////////////////////////////////////////////////////////////
-//  File: User.cpp
+// $Id: User.cpp,v 1.70 2005/01/23 01:34:53 klas Exp $
+//
 // Usage: Holds information about connected users.
 //
 //  A part of babyftpd, licensed under the GNU GPL, see the file
@@ -11,60 +12,96 @@
 #include "User.h"
 
 Data::Data(User *user, int file_id, string file_name, int trans_type){
-  pthread_mutex_init(&data_lock, NULL);
+  sem_wait(&user->user_lock);
+  sem_init(&data_lock, 0, 1);
+
   Data::file_id = file_id;
   Data::file_name = file_name;
-  Data::data_id = user->data_id;
   Data::data_addr = user->data_addr;
   Data::settings = user->settings;
   Data::user = user;
   if(trans_type == 1)
-    set_bit(this->settings, RETR_TRANS);
-  set_bit(Data::settings, OPEN);
+    this->settings.set(RETR_TRANS);
+
+  this->settings.set(DATA_OPEN);
   Data::rest_pos = 0;
 #ifdef USE_TLS
-  remove_bit(Data::settings, TLS_INITED);
-  remove_bit(Data::settings, TLS_ENABLED);
+  this->settings.reset(TLS_INITED);
+  this->settings.reset(TLS_ENABLED);
 #endif // USE_TLS
   
-  if(!is_set(user->settings, PASSIVE))
+  if(user->settings.test(PASSIVE))
+  {
+    socklen_t len = sizeof(this->data_addr);
+    if((this->data_id = accept(user->data_id, reinterpret_cast<struct sockaddr*>(&this->data_addr), &len)) < 0)
+      this->settings.reset(DATA_OPEN);
+    close(user->data_id);
+  }
+  else // ACTIVE
   { 
     if(this->data_id)
       close(Data::data_id);
-    this->data_id = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
-    if(connect(this->data_id, (struct sockaddr*)&this->data_addr, sizeof(this->data_addr)) < 0)
-      remove_bit(Data::settings, OPEN);
     
-  }
-  else
+    this->data_id = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
+    int on = 1;
+    setsockopt(this->data_id, SOL_SOCKET, SO_REUSEADDR,
+        (static_cast<void*>(&on)), sizeof(on));
+    struct sockaddr_in my_addr;
+    my_addr.sin_port = htons(20);
+    my_addr.sin_addr.s_addr = htonl(INADDR_ANY);
+    // active connections should originate at port 20, for that we need root.
+    uid_t old_uid = geteuid();
+    seteuid(0);
+    int ret = bind(this->data_id, reinterpret_cast<struct sockaddr*>
+        (&my_addr), sizeof(my_addr));
+    seteuid(old_uid);
+    if(ret != 0)
+      logging->log_this(3, LOG_INFO,
+          "Failed to bind to data port 20, falling back to arbitrary port.");
+
+    if(connect(this->data_id, reinterpret_cast<struct sockaddr*>
+          (&this->data_addr), sizeof(this->data_addr)) < 0)
+      this->settings.reset(DATA_OPEN);
+  }
+  // if the data connection comes from another host than the
+  // ctrl connection we drop it.. unless the user is tls protected.
+  if(this->data_addr.sin_addr.s_addr != user->ctrl_addr.sin_addr.s_addr)
   { 
-    socklen_t len = sizeof(this->data_addr);
-    if((this->data_id = accept(this->data_id, (struct sockaddr*)&this->data_addr, &len)) < 0)
-      remove_bit(Data::settings, OPEN);
+#ifdef USE_TLS
+    if(!user->settings.test(TLS_ENABLED))
+    {
+#endif // USE_TLS
+      close(this->data_id);
+      this->settings.reset(DATA_OPEN);
   }
 #ifdef USE_TLS
-  if(is_set(this->settings, TLS_PROT_D)) // settingup tls stuff, handshake later
+  }
+  if(this->settings.test(TLS_PROT_D)) // setting tls stuff up, handshake later
   { 
-    this->data_session = comm.init_tls();
-    set_bit(this->settings, TLS_INITED);
-    gnutls_transport_set_ptr(this->data_session, (gnutls_transport_ptr)this->data_id);
+    comm.init_tls(this->data_session);
+    this->settings.set(TLS_INITED);
+    gnutls_transport_set_ptr(this->data_session, reinterpret_cast<gnutls_transport_ptr>(this->data_id));
   }
 #endif //USE_TLS
+  sem_post(&user->user_lock);
 }
 
-bool Data::isOpen()
+bool Data::isOpen() const
 {
-  return(is_set(Data::settings, OPEN));
+  return(this->settings.test(DATA_OPEN));
 }
 
 Data::~Data(){
-  pthread_mutex_unlock(&data_lock);
+  if(data_id)
   close(data_id);
+  if(file_id)
   close(file_id);
-  pthread_mutex_destroy(&data_lock);
+
+  sem_destroy(&data_lock);
+
 #ifdef USE_TLS
   // TLS cleanup here.
-  if(is_set(this->settings, TLS_INITED))
+  if(this->settings.test(TLS_INITED))
   {
     gnutls_db_remove_session(this->data_session);
     gnutls_deinit(this->data_session);
@@ -73,16 +110,16 @@ Data::~Data(){
           
   if(!pthread_equal(pthread_self(), user->thread_id))
   {
-    pthread_mutex_lock(&user->lock);
+    sem_wait(&user->user_lock);
     user->data_vec.erase(user->get_data_it(pthread_self()));
-    pthread_mutex_unlock(&user->lock);
-    cout << "data thread " << thread_id << " exiting. Remaining data connections for " << user->user_name << " is: " << user->data_vec.size() << endl;
-    //pthread_exit(NULL); // this would cause a mem leak as the object isn't fully deleted, and the thread is calling delete data.
+    sem_post(&user->user_lock);
+    logging->log_this(4, TYPE_INFO, "data thread " + util.itos(thread_id) + " exiting. Remaining data connections for " + user->user_name + " is: " + util.itos(user->data_vec.size()));
   }
 }
 
 User::User(int socket_id, struct sockaddr_in &addr){
-  pthread_mutex_init(&lock, NULL);
+  sem_init(&user_lock, 0, 1);
+
   User::ctrl_addr = addr;
   User::socket_id = socket_id;
   User::logged_in = NOT_LOGGED_IN;
@@ -92,39 +129,51 @@ User::User(int socket_id, struct sockadd
   User::host_name = inet_ntoa(User::ctrl_addr.sin_addr);
   User::root_dir = "/";
   User::failed_logins = 0;
-  User::settings = 0;
+  User::total_transfered = 0;
+  this->settings.reset();
 
   // setting the bitflags on mlst_facts... not to clean..
-  User::mlst_facts = FACT_TYPE | FACT_SIZE | FACT_MODIFY | FACT_UNIQUE | FACT_U_MODE | FACT_U_UID | FACT_U_GID | FACT_U_LINK | FACT_PERM;
+  for(int i = 0; i <= LAST_FACT; i++)
+    this->settings.set(i);
 }
 
 User::~User(){
-  pthread_mutex_unlock(&lock);
+  if(socket_id)
   close(socket_id);
+  if(data_id)
+    close(data_id);
+
+  if(settings.test(PAM_DONE))
+  {
+    sem_wait(&comm.pam_lock);
+    pam_close_session(pamh, PAM_SILENT);
+    pam_end(pamh, PAM_SUCCESS);
+    sem_post(&comm.pam_lock);
+  }
+
+  sem_destroy(&user_lock);
   
   // killing off any ongoing data threads
   for(vector<Data*>::iterator data_it = data_vec.begin(); data_it != data_vec.end(); data_it++)
-    pthread_kill((*data_it)->thread_id, 15);
+    if(*data_it)
+      pthread_cancel((*data_it)->thread_id);
 
   while(data_vec.size())
   {  }
 
 #ifdef USE_TLS
   // TLS cleanup here.
-  if(is_set(this->settings, TLS_INITED))
+  if(this->settings.test(TLS_INITED))
   {
     gnutls_db_remove_session(this->ctrl_session);
     gnutls_deinit(this->ctrl_session);
   }
 #endif
   
-  pthread_mutex_destroy(&lock);
-  pthread_mutex_lock(&user_list_mutex);
+  sem_wait(&user_list_lock);
   user_list.erase(get_user_it(pthread_self()));
-  pthread_mutex_unlock(&user_list_mutex);
-  pthread_kill(dns_thread, 9);
-  cout << "user thread " << thread_id << " exiting, connected users:" << user_list.size() << ".\r\n";
-  //pthread_exit(NULL); // We do NOT want to pthread_exit here, then the object isn't fully destroyed.
+  sem_post(&user_list_lock);
+  logging->log_this(3, TYPE_INFO, "user thread " + util.itos(thread_id) + " exiting, connected users:" + util.itos(user_list.size()));
 }
 
 vector<User*>::iterator get_user_it(pthread_t thread_id)
@@ -150,9 +199,19 @@ vector<Data*>::iterator User::get_data_i
   return(data_it);
 }
 
-bool User::data_vec_full(){
-  if(data_vec.size() >= (size_t)config->get_user(user_name).sim_data)
+bool User::data_vec_full() const
+{
+  if(data_vec.size() >= static_cast<size_t>(config->get_user(user_name).sim_data))
     return(true);
   return(false);
 }
 
+void kill_user(void *user)
+{
+  delete static_cast<User*>(user);
+}
+  
+void kill_data(void *data)
+{
+  delete static_cast<Data*>(data);
+}
Index: User.h
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/User.h,v
retrieving revision 1.62
retrieving revision 1.74
diff -u -p -b -r1.62 -r1.74
--- User.h	10 Jul 2004 14:14:45 -0000	1.62
+++ User.h	16 Jan 2005 00:55:24 -0000	1.74
@@ -1,5 +1,6 @@
 /////////////////////////////////////////////////////////////////////
-//  File: User.h
+// $Id: User.h,v 1.74 2005/01/16 00:55:24 klas Exp $
+//
 // Usage: Holds information about connected users.
 //
 //  A part of babyftpd, licensed under the GNU GPL, see the file
@@ -14,6 +15,8 @@
 #include "Configuration.h"
 #include "Handler.h"
 #include "Commands.h"
+#include "Utilities.h"
+#include "Log.h"
 #endif
 
 #define NOT_LOGGED_IN 0
@@ -21,31 +24,39 @@
 #define LOGGED_IN 2
 #define LOGGED_OUT 3
 
-#define FACT_TYPE (1 << 0) // for mlsx
-#define FACT_SIZE (1 << 1)
-#define FACT_MODIFY (1 << 2)
-#define FACT_UNIQUE (1 << 3)
-#define FACT_U_MODE (1 << 4)
-#define FACT_U_UID (1 << 5)
-#define FACT_U_GID (1 << 6)
-#define FACT_U_LINK (1 << 7)
-#define FACT_PERM (1 << 8)
-
-#define DATA_ACCT (1 << 0) // for settings
-#define BINARY (1 << 1)
-#define COMPRESSED (1 << 2)
-#define PASSIVE (1 << 3)
-#define ANONYMOUS (1 << 4)
-#define OPEN (1 << 5)
-#define EPSV_ONLY (1 << 6)
-#define RETR_TRANS (1 << 7)
+#define FACT_TYPE 0 // for mlsx
+#define FACT_SIZE 1
+#define FACT_MODIFY 2
+#define FACT_UNIQUE 3
+#define FACT_U_MODE 4
+#define FACT_U_UID 5
+#define FACT_U_GID 6
+#define FACT_U_LINK 7
+#define FACT_PERM 8
+#define LAST_FACT 8
+
+#define DATA_ACCT 9
+#define BINARY 10
+#define COMPRESSED 11
+#define PASSIVE 12
+#define ANONYMOUS 13
+#define DATA_OPEN 14
+#define EPSV_ONLY 15
+#define RETR_TRANS 16
+#define PAM_DONE 17
 #ifdef USE_TLS
-#define TLS_ENABLED (1 << 20)
-#define TLS_INITED (1 << 21)
-#define TLS_PBSZ (1 << 22)
-#define TLS_PROT_D (1 << 23)
+#define TLS_ENABLED 18
+#define TLS_INITED 19
+#define TLS_PBSZ 20
+#define TLS_PROT_D 21
+
+// keep an eye on these.. different depending on TLS or not...
+#define TOTAL_U_BIT 22
+#else
+#define TOTAL_U_BIT 18
 #endif // USE_TLS
 
+
 class Data
 {
   private:
@@ -53,16 +64,15 @@ class Data
   public:
     Data(User *user, int file_id = -1, string file_name = "", int trans_type = 0);
     ~Data();
-    bool isOpen();
+    bool isOpen() const;
     int data_id;
     struct sockaddr_in data_addr;
     int trans_type;
     int file_id;
-    unsigned int settings;
+    bitset<TOTAL_U_BIT> settings;
     off_t rest_pos;
-    pthread_mutex_t data_lock;
+    sem_t data_lock;
     pthread_t thread_id;
-    pthread_t dns_thread;
     string file_name;
     string host_name; // NEVER modify this after dns_lookup thread is spawned. never.
     User *user;
@@ -76,7 +86,7 @@ class User
   public:
     User(int socket_id, struct sockaddr_in &addr);
     vector<Data*>::iterator get_data_it(pthread_t);
-    bool data_vec_full();
+    bool data_vec_full() const;
     ~User();
     vector<Data*> data_vec;
     string user_name;
@@ -89,26 +99,30 @@ class User
     string current_dir;
     string root_dir;
     string temp_buf; // is this for anything but rename? shouldn't be the way I just changed it around -kl
-    unsigned int mlst_facts; // bit vector for mlsx
-    unsigned int settings; // bit vector for other settings
+    bitset<TOTAL_U_BIT> settings;
     int failed_logins;
     off_t rest_pos;
-    pthread_mutex_t lock;
+    unsigned long long total_transfered; // this variable will hold the total number of transfered bytes.
+    sem_t user_lock;
     pthread_t thread_id;
-    pthread_t dns_thread;
 #ifdef USE_TLS
     gnutls_session ctrl_session;
 #endif // USE_TLS
+    pam_handle_t *pamh;
 };
 
 vector<User*>::iterator get_user_it(pthread_t);
+void kill_user(void*);
+void kill_data(void*);
 
-extern pthread_key_t my_object;
-extern pthread_mutex_t user_list_mutex;
+extern pthread_key_t my_user;
+extern pthread_key_t my_data;
+extern sem_t user_list_lock;
 extern pthread_t main_thread;
 extern vector<User*> user_list;
 extern class Configuration *config;
 extern class Handler handler;
 extern class Commands comm;
+extern class Utilities util;
 
 #endif
Index: Utilities.cpp
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/Utilities.cpp,v
retrieving revision 1.36
retrieving revision 1.40
diff -u -p -b -r1.36 -r1.40
--- Utilities.cpp	24 Dec 2002 00:42:11 -0000	1.36
+++ Utilities.cpp	8 Jan 2005 22:42:18 -0000	1.40
@@ -1,5 +1,6 @@
 /////////////////////////////////////////////////////////////////////
-//  File: Utilities.cpp
+// $Id: Utilities.cpp,v 1.40 2005/01/08 22:42:18 klas Exp $
+//
 // Usage: Various functions that doesn't belong anywhere else.
 //
 //  A part of babyftpd, licensed under the GNU GPL, see the file
@@ -18,13 +19,6 @@ void Utilities::strip_line_breaks(string
     victim = victim.erase(last);
 }
 
-// function to convert a string into upper case
-void Utilities::upper(string &orig_string)
-{
-  for(string::iterator upper_it = orig_string.begin(); upper_it != orig_string.end(); upper_it++)
-    *upper_it = toupper(*upper_it);
-}
-
 // function to clean a string from:
 //      leading spaces
 //      trailing spaces
@@ -44,7 +38,7 @@ int Utilities::clean_string(string &vict
   
   for(string::iterator victim_it = victim.begin(); victim_it != victim.end(); ++victim_it)
   {
-    if(isspace(*victim_it)) // yes klas, that isspace() is needed /kl 010826
+    if(isspace(*victim_it) || iscntrl(*victim_it))
     {
       if(*victim_it == ' ') // isspace() triggers on more than space...
         spaces++;
@@ -64,13 +58,11 @@ int Utilities::clean_string(string &vict
 string Utilities::itos(int num)
 {
   string message;
-  char *buf = new char[10];
-  memset((void*)buf, '\0', 10);
+  char buf[12];
   
-  snprintf(buf, 10, "%d", num);
+  snprintf(buf, 12, "%d", num);
   message = buf;
   
-  delete[] buf;
   return(message);
 }
 
Index: Utilities.h
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/Utilities.h,v
retrieving revision 1.23
retrieving revision 1.26
diff -u -p -b -r1.23 -r1.26
--- Utilities.h	20 May 2004 21:33:43 -0000	1.23
+++ Utilities.h	2 Dec 2004 22:28:42 -0000	1.26
@@ -19,11 +19,22 @@ class Utilities
 
   public:
     void strip_line_breaks(string&);
-    void upper(string&);
     int clean_string(string&);
     string itos(int);
     string parse_perms_ls(mode_t);
     string parse_perms_num(mode_t);
+
+    // small inline functions, previously macros
+    bool test(int a, int b)
+    { return((a & b) == b); }
+    bool is_set(unsigned int flag, unsigned int bit)
+    { return(flag & bit); }
+    void set_bit(unsigned int &flag, unsigned int bit)
+    { flag |= bit; }
+    void remove_bit(unsigned int &flag, unsigned int bit)
+    { flag &= ~bit; }
+    void toggle_bit(unsigned int &flag, unsigned int bit)
+    { flag ^= bit;  }
 };
 
 #endif
